using Microsoft.IdentityModel.Tokens;

namespace Infrastructure.Security;

/// <summary>
/// 自定义token解密
/// </summary>
/// <param name="encryptionService"></param>
/// <param name="jwtSecurityTokenHandler"></param>
public class DefaultTokenHandler(IEncryptionService encryptionService, JwtSecurityTokenHandler jwtSecurityTokenHandler)
    : TokenHandler
{
    public override Task<TokenValidationResult> ValidateTokenAsync(string token,
        TokenValidationParameters validationParameters)
    {
        var decodeToken = encryptionService.Decrypt(token);
        return jwtSecurityTokenHandler.ValidateTokenAsync(decodeToken, validationParameters);
    }
}